/*
 *  -:- LICENCE -:- 
 * Copyright Raffi Enficiaud 2007-2010
 * 
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file ../../LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
 * 
 *  -:- LICENCE -:- 
 */



#ifndef YAYI_COMMON_CONSTANTS__HPP__
#define YAYI_COMMON_CONSTANTS__HPP__

#include <boost/math/constants/constants.hpp>


/*!@file
 * Constants used in the program.
 */

//! The magic Pi number
#define yaPI      3.141592653589793238462643383279502884
//! Pi by 2
#define ya2PI     (2*yaPI)
//! Pi divided by 2
#define yaPI_d2   (yaPI/2)
//! Pi divided by 3
#define yaPI_d3   (yaPI/3)
//! 2*Pi divided by 3
#define ya2PI_d3  (2*yaPI/3)

//! sqrt(3) / 2
#define yaSqrt3_d2 0.866025403784439

//! 2/sqrt(3)
#define ya2_dSqrt3 1.154700538379252

namespace yayi
{


}
 
#endif // YAYI_COMMON_CONSTANTS__HPP__
